%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%global soname 0
# fife.ppc: W: devel-file-in-non-devel-package /usr/lib/libfife.so <- just a symlink, shouldn't be in -devel. It's used by the client(s) 

Name:           fife
Epoch:          1
Version:        0.3.1
Release:        2%{?dist}
Summary:        Cross platform game creation framework

Group:          Amusements/Games
License:        LGPLv2+
URL:            http://www.fifengine.de
# https://sourceforge.net/projects/fife/files/active/src/fife-0.3.0.tar.gz/download
# removed ext/   -  removed for using system libs instead of shipped
# removed tests/   -  removed for legal issues
# removed tools/   -  removed for legal issues
Source0:        %{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch0:         %{name}-0.3.1-soname.patch
Patch1:         %{name}-0.3.1-dso.patch
Patch3:         %{name}-0.3.1-boost.patch

BuildRequires:  scons
BuildRequires:  SDL-devel
BuildRequires:  boost-devel
BuildRequires:  SDL_ttf-devel
BuildRequires:  SDL_image-devel
BuildRequires:  libvorbis-devel
BuildRequires:  openal-devel
BuildRequires:  swig
BuildRequires:  python-devel
BuildRequires:  zlib-devel
BuildRequires:  mesa-libGLU-devel
BuildRequires:  guichan-devel
BuildRequires:  libpng-devel
BuildRequires:  graphviz
BuildRequires:  libXcursor-devel
BuildRequires:  chrpath

Provides:       %{name}-python = %{epoch}:%{version}-%{release}


%description
This package of Fife comes with game-engine only.
Unknown horizons is one of the clients that will use this engine.


%package  devel
Summary:  Development package for %{name}
Group:    Development/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}


%description devel
Files for development with %{name}.


%package  static
Summary:  Static library for %{name} development
Group:    Development/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}


%description static
The %{name}-static package includes static library needed to develop programs
that use the %{name} library.


%package doc
Summary:       Documentation for %{name}
Group:         Documentation
BuildRequires: doxygen
BuildArch:     noarch
Requires:      %{name} = %{epoch}:%{version}-%{release}


%description doc
Doxygen generated documentation for %{name}. 


%prep
%setup -q 

# remove usage of ./ext/ (see line 16 for further informations)
# very dirrty, but it works
sed -i '21d' \
    build/linux2-config.py

# use libdir instead of lib (for 64bit systems)
for l in ./engine/SConscript ./build/linux2-config.py
do
 sed -i "s|'lib'|'%{_lib}'|g" $l
done 

# be utf-8 clean, dudes!
for f in ./AUTHORS ./CHANGES ./COPYING ./README
do
 iconv -f iso-8859-1 -t utf-8 $f |sed 's|\r||g' > $f.utf8
 touch -c -r $f $f.utf8
 mv $f.utf8 $f
done 

# correction of leaf
sed -i 's|i->leaf()|i->path().leaf()|g' \
    engine/core/vfs/vfsdirectory.cpp

# no soname? You can not be serious!
%patch0 -p1
sed -i "s|SONAME|%{soname}|g" \
    engine/SConscript

#DSO for the boostsystem
%patch1 -p1

# link against boost_filesystem
%patch3 -p1

%build
scons . \
      CXXFLAGS='%{optflags}' \
      %{?jobs:-j%{jobs}} \
      --enable-debug \
      --enable-rend-grid \
      --enable-rend-camzone \
              fife-shared fife-static fife-python fife-swig

# Doxygen generated docs
doxygen ./doc/doxygen/doxyfile
rm -f ./doc/doxygen/html/installdox


%install
rm -rf %{buildroot}

scons . \
      CXXFLAGS='%{optflags}' \
      --enable-debug \
              install-all \
              install-dev \
                     DESTDIR=%{buildroot} \
                            --prefix=%{_prefix} \
                            --python-prefix=%{python_sitelib}

# rpath is evil, evil, evil
chrpath --delete %{buildroot}%{_libdir}/lib%{name}.so
chrpath --delete %{buildroot}%{python_sitelib}/%{name}/_%{name}.so

# playing a little bit with soname
mv %{buildroot}/%{_libdir}/lib%{name}.so %{buildroot}/%{_libdir}/lib%{name}.so.%{version}
pushd %{buildroot}%{_libdir}
ln -s lib%{name}.so.%{version} lib%{name}.so.%{soname}
ln -s lib%{name}.so.%{version} lib%{name}.so
popd

mkdir -p %{buildroot}/%{_bindir}/
cat > %{buildroot}/%{_bindir}/%{name}-documentation << EOF
#!/bin/sh
xdg-open file://%{_docdir}/%{name}-doc-%{version}/index.html
EOF
chmod +x %{buildroot}/%{_bindir}/%{name}-documentation

# fife.ppc: E: non-standard-executable-perm /usr/lib/libfife.so.0 0775
chmod 755 %{buildroot}/%{_libdir}/lib%{name}.so.%{soname}
# fife.ppc: E: non-standard-executable-perm /usr/lib/python2.6/site-packages/fife/_fife.so 0775
chmod 755 %{buildroot}/%{python_sitelib}/%{name}/_%{name}.so


%post -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc AUTHORS CHANGES COPYING README
%{_libdir}/lib%{name}.so
%{_libdir}/lib%{name}.so.%{soname}
%{_libdir}/lib%{name}.so.%{version}
%{python_sitelib}/%{name}/


%files devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/


%files static
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.a


%files doc
%defattr(-,root,root,-)
%doc ./doc/doxygen/html/*
%{_bindir}/%{name}-documentation



%changelog
* Thu Apr 29 2010 Thomas Spura <tomspur@fedoraproject.org> - 1:0.3.1-2
- also link against boost_filesystem

* Wed Apr 07 2010 Simon Wesp <cassmodiah@fedoraproject.org> - 1:0.3.1-1
- pdate to 0.3.1
 
* Tue Mar 09 2010 Thomas Kowaliczek <linuxdonald@linuxdonald.de> - 1:0.3.0-4
- Fixed Bug #564752
- Thanks for the patch Terje

* Mon Feb 01 2010 Simon Wesp <cassmodiah@fedoraproject.org> - 1:0.3.0-3
- Cosmetical Issues

* Sun Jan 31 2010 Simon Wesp <cassmodiah@fedoraproject.org> - 1:0.3.0-2
- Split devel package and add a static subpackage
- Generate doxygen docs and add a doc subpackage
- Correct epoch usage
- Create and use soname
- Honor CFLAGS
- Correct leaf
- Cleanup

* Wed Jan 27 2010 Simon Wesp <cassmodiah@fedoraproject.org> - 1:0.3.0-1
- update to 0.3.0

* Tue Jan 21 2010 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.28.r3111svn
- Rebuild for updated boost

* Sat Dec 12 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.27.r3111svn
- Update to r3111

* Thu Oct 08 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.26.r3056svn
- There are no errors revoked spec changes!

* Thu Oct 08 2009 Thomas Kowaliczek <linuxdonald@linuxdonald.de> - 2009.0-0.25.r3056svn
- Update to r3056 and fixed some spec errors

* Tue Sep 29 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.24.r3054svn
- Update to r3054

* Mon Sep 28 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.23.r3053svn
- Update to r3053

* Mon Sep 28 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.22.r3052svn
- Update to r3052

* Sun Sep 27 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.21.r3051svn
- Update to r3051

* Fri Sep 25 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.20.r3050svn
- Update to r3050

* Wed Sep 23 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.19.r3049svn
- Update to r3049

* Tue Sep 22 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.18.r3048svn
- Update to r3048

* Mon Sep 21 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.17.r3047svn
- Update to r3047

* Mon Sep 21 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.16.r3046svn
- Update to r3046

* Mon Sep 21 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.15.r3045svn
- Update to r3045

* Thu Aug 20 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.14.r2955svn
- Update to r2955
- Honor OPTFLAGS

* Sat Jul 11 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.13.r2954svn
- Update to r2954
- Link follow files, because they are equal
   LIBDIR/NAME/engine/libNAME.so
   LIBDIR/NAME/engine/swigwrappers/python/_NAME.so

* Fri Jul 10 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.12.r2953svn
- Update to r2953
- Remove all outcommented spec-code

* Fri Jul 10 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.11.r2952svn
- Correct rpath in source instead of binary

* Fri Jul 10 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.10.r2952svn
- Update to r2952
- Remove ldconfig from POST and POSTUN
- Correct license to LGPLv2+

* Wed Jul 08 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.9.r2951svn
- Update to r2951

* Wed Jul 08 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.8.r2947svn
- Remove tests and clients from source0 for legal issues
- Remove ext from source0 instead of remove via 'rm' in spec - to proof that there is no internal shipped dependency in build process
- Remove doc subpackage

* Sun Jul 05 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.7.r2947svn
- Update to r2947

* Sun Jul 05 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.6.r2946svn
- Update to r2946

* Sun Jul 05 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.5.r2945svn
- Update to r2945

* Sun Jul 05 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.4.r2944svn
- Making RPMLINT happy
- Correct file permissions and add missed shebangs

* Sun Jul 05 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.3.r2944svn
- Update to r2944

* Sat Jun 13 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.2.r2916svn
- Update to r2916

* Sun Mar 29 2009 Simon Wesp <cassmodiah@fedoraproject.org> - 2009.0-0.1.r2761svn
- Initial release
